#ifndef	_CRT_SECURE_NO_DEPRECATE
#define	_CRT_SECURE_NO_DEPRECATE
#endif

#include "irensei_ai_descripter.h"
#include <windows.h>
#include <stdarg.h>
#include <stdio.h>


// LoadLibrary()  DLL  HMODULE AIRENSEI_AI_DESC 쐬B
// ߂ĺA1.., 0..s
int MakeIrenseiAiDesc( IRENSEI_AI_DESC * desc, HMODULE hmod )
{
	static const char * baseProcNames[] = {		// K{֐
		"IrenseiGetName",
		"IrenseiGetFirstVersion",
		"IrenseiGetLastVersion",
		"IrenseiInitialize",
		"IrenseiFinalize",
		"IrenseiThink",
	};

	// K{֐`FbN
	{
		int lpc;
		for ( lpc = 0; lpc < sizeof(baseProcNames)/sizeof(*baseProcNames); lpc++ ) {
			if ( ! GetProcAddress( hmod, baseProcNames[lpc] ) )
				return 0;
		}
	}

	// p^o^
	{
		FARPROC proc;
		proc = GetProcAddress( hmod, "IrenseiGetName" );
		(*(int(*)(char[32]))proc)( desc->name );
		proc = GetProcAddress( hmod, "IrenseiGetFirstVersion" );
		desc->firstVersion = (*(int(*)(void))proc)();
		proc = GetProcAddress( hmod, "IrenseiGetLastVersion" );
		desc->lastVersion = (*(int(*)(void))proc)();
		if ( 0 != (proc = GetProcAddress( hmod, "IrenseiDebugCount" )) ) {
			desc->countDebug = (*(int(*)(void))proc)();
		} else {
			desc->countDebug = 0;
		}
		desc->initialize = (int(*)(const IRENSEI_RULE_DESCRIPTION*,int,int))
				GetProcAddress( hmod, "IrenseiInitialize" );
		desc->finalize = (int(*)(int,int))GetProcAddress( hmod, "IrenseiFinalize" );
		desc->think = (int(*)(int,IRENSEI_BOARD_POSITION*,const IRENSEI_BOARD_POSITION*, int))
				GetProcAddress( hmod, "IrenseiThink" );
		desc->undo = (int(*)(int,IRENSEI_BOARD_POSITION*,int))GetProcAddress( hmod, "IrenseiUndo" );
		desc->debug = (int(*)(int,IRENSEI_DEBUG_BOARD*,int,int))
				GetProcAddress( hmod, "IrenseiDebug" );
	}

	return 1;
}



// `ĥ߂̃fobO[eBeB[ printf ֊֐
BOOL IrenseiPrintf( HANDLE hout, const char * fmt, ... )
{
	DWORD lpNumberOfBytesWritten;
	char buf[4096];
	buf[ sizeof(buf)-1 ] = 0;

	{
		va_list argptr;
		va_start( argptr, fmt );
		vsprintf( buf, fmt, argptr );
		va_end( argptr );
	}

	return WriteFile( hout, buf, (DWORD)strlen(buf), &lpNumberOfBytesWritten, 0 );
}


